% A feladat: egy tetszleges kifejezshez soroljuk fel a benne lev
% szmokat, s minden szm esetn adjuk meg annak a kivlasztjt!
% Egy rszkifejezs kivlasztja egy olyan lista, amely megadja, mely
% argumentumpozcik mentn juthatunk el hozz. 
%  Pl. a*b+f(1,2,3)/c-ben  b kivlasztja  [1,2], 3 kivlasztja [2,1,3].


% kif_szm(?Kif, ?N, ?Kiv): Kif Kiv kivlasztj rsze az N szm.
kif_szm(X, N, Kiv) :- 
        number(X), !, N = X, Kiv = [].
kif_szm(X, N, [I|Kiv]) :-
        compound(X),                   % a vltoz kizrsa miatt fontos!
        functor(X, _F, ArgNo),
	between(1, ArgNo, I),
	arg(I, X, X1),
        kif_szm(X1, N, Kiv).

% between(M, N, I): M =< I =< N, I egsz.
between(M, N, M) :-
        M =< N.
between(M, N, I) :-
        M < N, 
        M1 is M+1,
        between(M1, N, I).
