% A feladat: egy tetszleges kifejezs kiiratsa gy, hogy
% - a ktargumentum opertorok zrjelezett infix formban,
% - minden ms alap-struktra alakban jelenjk meg. 
ki(Kif) :- 
	compound(Kif), !,
	Kif =.. [Func, A1|ArgL],       % ArgL az 1. utni argumentumok
	(   ArgL = [A2],               % mg 1 arg. van, sszesen teht 2   
	    current_op(_, Kind, Func), % a funktor opertor
	    infix_fajta(Kind)          % amely infix fajtj
	    % teht: ktargumentum kifejezs, funktora infix opertor
	    ->  write('('), ki(A1), write(' '), write(Func),
	    write(' '), ki(A2), write(')')
	;   write(Func), 
	    write('('), ki(A1), arglistaki(ArgL), write(')')
	).
ki(Kif) :- write(Kif).

% infix_fajta(F): F egy infix opertorfajta.
infix_fajta(xfx).
infix_fajta(xfy).
infix_fajta(yfx). 

% Az [A1,...,An] listt ",A1,...,An" alakban kirja.
arglistaki([]).
arglistaki([A|AL]) :-
	write(','),
	ki(A),
	arglistaki(AL).
