% length(?L, ?N): Az L lista N hossz.
mylength(L, N) :-
	var(N), !,
	length(L, 0, N).   
mylength(L, N) :-
	dlength(L, 0, N).  

% length(?L, +I0, -I):    Az L lista I-I0 hossz.
length([], I, I).            
length([_|L], I0, I) :-      
        I1 is I0+1,          
        length(L, I1, I).    

% dlength(?L, +I0, +I):   Az L lista I-I0 hossz.
dlength([], I, I) :- !.      
dlength([_|L], I0, I) :-     
        I0<I,
	I1 is I0+1,    
        dlength(L, I1, I).        
