% Figyelem! Ezekben a peldkban nem tartjuk be a vgs alapszablyt.
% Ezert ezek a pldk nem olyan hatkonyak, mint a vago_peldak[23].pl
% llomnyokban kzlt vltozatok. Emellett a pozitvak/2 ellenrz
% mdban hibs eredmnyt is adhat, pl.:
%             | ?- pozitvak([1], []).
%             yes

% fakt(+N, ?F): N! = F.
fakt(0, 1) :- !.                                          % zld vg
fakt(N, F) :- N > 0, N1 is N-1, fakt(N1, F1), F is N*F1.

% last(+L, ?E): az L lista utols eleme E. (A lists knyvtrban van!)
last([E], E) :- !.                                        % zld vg
last([_|L], E) :- last(L, E).

% pozitvak(+L, -P): P az L pozitv elemeibl ll.
pozitvak([], []).
pozitvak([E|Ek], [E|Pk]) :-
       E > 0, !,                                          % vrs vg
       pozitvak(Ek, Pk).
pozitvak([_E|Ek], Pk) :-
       /* \+ _E > 0, */ pozitvak(Ek, Pk).
